diff --git a/gcc/objc/objc-gnu-runtime-abi-01.c b/gcc/objc/objc-gnu-runtime-abi-01.c
index 8cfa1f8..44e7258 100644
--- a/gcc/objc/objc-gnu-runtime-abi-01.c
+++ b/gcc/objc/objc-gnu-runtime-abi-01.c
@@ -127,18 +127,18 @@ bool
 objc_gnu_runtime_abi_01_init (objc_runtime_hooks *rthooks)
 {
   /* GNU runtime does not need the compiler to change code in order to do GC. */
-  if (flag_objc_gc)
+  if (GCC_OPTION (flag_objc_gc))
     {
       warning_at (0, 0, "%<-fobjc-gc%> is ignored for %<-fgnu-runtime%>");
-      flag_objc_gc = 0;
+      GCC_OPTION (flag_objc_gc) = 0;
     }
 
   /* Although I guess we could, we don't currently support SJLJ exceptions for the
      GNU runtime.  */
-  if (flag_objc_sjlj_exceptions)
+  if (GCC_OPTION (flag_objc_sjlj_exceptions))
     {
       inform (UNKNOWN_LOCATION, "%<-fobjc-sjlj-exceptions%> is ignored for %<-fgnu-runtime%>");
-      flag_objc_sjlj_exceptions = 0;
+      GCC_OPTION (flag_objc_sjlj_exceptions) = 0;
     }
 
   /* TODO: Complain if -fobjc-abi-version=N was used.  */
@@ -660,7 +660,7 @@ build_objc_method_call (location_t loc, int super_flag, tree method_prototype,
 			tree method_params)
 {
   tree sender = (super_flag ? umsg_super_decl
-			    : (flag_objc_direct_dispatch ? umsg_fast_decl
+			    : (GCC_OPTION (flag_objc_direct_dispatch) ? umsg_fast_decl
 							 : umsg_decl));
   tree rcv_p = (super_flag ? objc_super_type : objc_object_type);
   vec<tree, va_gc> *parms;
@@ -1537,7 +1537,7 @@ build_shared_structure_initializer (tree type, tree isa, tree super,
     }
 
   /* FIXME: Remove NeXT runtime code.  */
-  if (flag_next_runtime)
+  if (GCC_OPTION (flag_next_runtime))
     {
       ltyp = build_pointer_type (xref_tag (RECORD_TYPE,
 					   get_identifier ("objc_cache")));
@@ -1569,7 +1569,7 @@ build_shared_structure_initializer (tree type, tree isa, tree super,
     }
 
   /* FIXME: Remove NeXT runtime code.  */
-  if (flag_next_runtime)
+  if (GCC_OPTION (flag_next_runtime))
     /* sel_id = NULL */
     CONSTRUCTOR_APPEND_ELT (v, NULL_TREE, build_int_cst (NULL_TREE, 0));
 
@@ -1817,7 +1817,7 @@ build_gnu_selector_translation_table (void)
   for (chain = sel_ref_chain; chain; chain = TREE_CHAIN (chain))
     {
       tree encoding;
-      if (warn_selector)
+      if (GCC_OPTION (warn_selector))
 	{
 	  /* TODO: improve on the location for the diagnostic.  */
 	  location_t loc = input_location;
@@ -1861,7 +1861,7 @@ generate_static_references (void)
   vec<constructor_elt, va_gc> *decls = NULL;
 
   /* FIXME: Remove NeXT runtime code.  */
-  if (flag_next_runtime)
+  if (GCC_OPTION (flag_next_runtime))
     gcc_unreachable ();
 
   for (cl_chain = objc_static_instances, num_class = 0;
@@ -2078,7 +2078,7 @@ objc_generate_v1_gnu_metadata (void)
       /* If -gen-decls is present, Dump the @interface of each class.
 	 TODO: Dump the classes in the  order they were found, rather than in
 	 reverse order as we are doing now.  */
-      if (flag_gen_declaration)
+      if (GCC_OPTION (flag_gen_declaration))
 	dump_interface (gen_declaration_file, impent->imp_context);
 
       /* all of the following reference the string pool...  */
diff --git a/gcc/objc/objc-next-runtime-abi-01.c b/gcc/objc/objc-next-runtime-abi-01.c
index 1879d10..5280dfc 100644
--- a/gcc/objc/objc-next-runtime-abi-01.c
+++ b/gcc/objc/objc-next-runtime-abi-01.c
@@ -90,7 +90,7 @@ along with GCC; see the file COPYING3.  If not see
 /* The version identifies which language generation and runtime the
    module (file) was compiled for, and is recorded in the module
    descriptor.  */
-#define OBJC_VERSION			(flag_objc_abi >= 1 ? 7 : 6)
+#define OBJC_VERSION			(GCC_OPTION (flag_objc_abi) >= 1 ? 7 : 6)
 
 #define UTAG_CLASS_EXT			"_objc_class_ext"
 #define UTAG_PROPERTY_LIST		"_prop_list_t"
@@ -145,8 +145,8 @@ static tree finish_try_stmt (struct objc_try_context **);
 bool
 objc_next_runtime_abi_01_init (objc_runtime_hooks *rthooks)
 {
-  if (flag_objc_exceptions
-      && !flag_objc_sjlj_exceptions)
+  if (GCC_OPTION (flag_objc_exceptions)
+      && !GCC_OPTION (flag_objc_sjlj_exceptions))
     {
       warning_at (UNKNOWN_LOCATION, OPT_Wall,
 		"%<-fobjc-sjlj-exceptions%> is the only supported exceptions "
@@ -266,7 +266,7 @@ static void next_runtime_01_initialize (void)
      will be placed in the correct sections.  */
   next_runtime_abi_01_init_metadata_attributes ();
 
-  if (flag_objc_abi >= 1)
+  if (GCC_OPTION (flag_objc_abi) >= 1)
     objc_prop_list_ptr = build_pointer_type (xref_tag (RECORD_TYPE,
 					     get_identifier ("_prop_list_t")));
 
@@ -384,7 +384,7 @@ static void next_runtime_01_initialize (void)
   objc_setPropertyStruct_decl = NULL_TREE;
 
   build_next_objc_exception_stuff ();
-  if (flag_objc_exceptions && !flag_objc_sjlj_exceptions)
+  if (GCC_OPTION (flag_objc_exceptions) && !GCC_OPTION (flag_objc_sjlj_exceptions))
     using_eh_for_cleanups ();
   lang_hooks.eh_runtime_type = objc_eh_runtime_type;
   lang_hooks.eh_personality = objc_eh_personality;
@@ -461,7 +461,7 @@ build_v1_class_template (void)
 					 get_identifier (UTAG_PROTOCOL))));
   add_field_decl (ptype, "protocol_list", &chain);
 
-  if (flag_objc_abi >= 1)
+  if (GCC_OPTION (flag_objc_abi) >= 1)
     {
       /* const char *ivar_layout; */
       add_field_decl (const_string_type_node, "ivar_layout", &chain);
@@ -519,7 +519,7 @@ build_v1_category_template (void)
   ptype = build_pointer_type (build_pointer_type (objc_protocol_template));
   add_field_decl (ptype, "protocol_list", &chain);
 
-  if (flag_objc_abi >= 1)
+  if (GCC_OPTION (flag_objc_abi) >= 1)
     {
       add_field_decl (integer_type_node, "size", &chain);
 
@@ -557,7 +557,7 @@ build_v1_protocol_template (void)
 
   objc_protocol_template = objc_start_struct (get_identifier (UTAG_PROTOCOL));
 
-  if (flag_objc_abi >= 1)
+  if (GCC_OPTION (flag_objc_abi) >= 1)
     /* struct _objc_protocol_extension *isa; */
     ptype = build_pointer_type (xref_tag (RECORD_TYPE,
 					  get_identifier (UTAG_PROTOCOL_EXT)));
@@ -690,7 +690,7 @@ build_class_reference_decl (void)
 static tree
 next_runtime_abi_01_get_class_reference (tree ident)
 {
-  if (!flag_zero_link)
+  if (!GCC_OPTION (flag_zero_link))
     {
       tree *chain;
       tree decl;
@@ -860,11 +860,11 @@ build_objc_method_call (location_t loc, int super_flag, tree method_prototype,
 	  || TREE_CODE (ret_type) == UNION_TYPE)
       && targetm.calls.return_in_memory (ret_type, 0))
     sender = (super_flag ? umsg_super_stret_decl
-			 : flag_nil_receivers ? umsg_stret_decl
+			 : GCC_OPTION (flag_nil_receivers) ? umsg_stret_decl
 					      : umsg_nonnil_stret_decl);
   else
     sender = (super_flag ? umsg_super_decl
-			 : (flag_nil_receivers  ? (flag_objc_direct_dispatch
+			 : (GCC_OPTION (flag_nil_receivers)  ? (GCC_OPTION (flag_objc_direct_dispatch)
 							? umsg_fast_decl
 							: umsg_decl)
 						: umsg_nonnil_decl));
@@ -956,7 +956,7 @@ next_runtime_abi_01_get_category_super_ref (location_t loc ATTRIBUTE_UNUSED,
   tree super_name = CLASS_SUPER_NAME (imp->imp_template);
   tree super_class;
 
-  if (!flag_zero_link)
+  if (!GCC_OPTION (flag_zero_link))
     {
       super_class = objc_get_class_reference (super_name);
 
@@ -1625,7 +1625,7 @@ generate_v1_protocols (void)
       else
         refs_expr = convert (refs_type, null_pointer_node);
 
-      if (flag_objc_abi < 1)
+      if (GCC_OPTION (flag_objc_abi) < 1)
 	{
 	  /* Original ABI.  */
 	  initlist =
@@ -1722,7 +1722,7 @@ build_v1_category_initializer (tree type, tree cat_name, tree class_name,
     expr = convert (ltyp, null_pointer_node);
   CONSTRUCTOR_APPEND_ELT (v, NULL_TREE, expr);
 
-  if (flag_objc_abi >= 1)
+  if (GCC_OPTION (flag_objc_abi) >= 1)
     {
       int val = TREE_INT_CST_LOW (TYPE_SIZE_UNIT (objc_category_template));
       expr = build_int_cst (NULL_TREE, val);
@@ -1767,7 +1767,7 @@ generate_v1_category (struct imp_entry *impent)
   else
     protocol_decl = 0;
 
-  if (flag_objc_abi >= 1)
+  if (GCC_OPTION (flag_objc_abi) >= 1)
     V1_Property_decl = generate_v1_property_table (NULL_TREE, cat);
   else
     V1_Property_decl = NULL_TREE;
@@ -1936,7 +1936,7 @@ build_v1_shared_structure_initializer (tree type, tree isa, tree super,
     expr = convert (ltyp, null_pointer_node);
   CONSTRUCTOR_APPEND_ELT (v, NULL_TREE, expr);
 
-  if (flag_objc_abi >= 1)
+  if (GCC_OPTION (flag_objc_abi) >= 1)
     {
       /* TODO: figure out the ivar_layout stuff.  */
       expr = convert (const_string_type_node, null_pointer_node);
@@ -2017,7 +2017,7 @@ generate_v1_class_structs (struct imp_entry *impent)
 
   loc = DECL_SOURCE_LOCATION (impent->class_decl);
 
-  if (flag_objc_abi >= 1)
+  if (GCC_OPTION (flag_objc_abi) >= 1)
     {
       /* ABI=1 additions.  */
       props = generate_v1_property_table (NULL_TREE, impent->imp_context);
@@ -2358,7 +2358,7 @@ objc_generate_v1_next_metadata (void)
       /* If -gen-decls is present, Dump the @interface of each class.
 	 TODO: Dump the classes in the  order they were found, rather than in
 	 reverse order as we are doing now.  */
-      if (flag_gen_declaration)
+      if (GCC_OPTION (flag_gen_declaration))
 	dump_interface (gen_declaration_file, impent->imp_context);
 
       /* all of the following reference the string pool...  */
@@ -2879,7 +2879,7 @@ build_throw_stmt (location_t loc, tree throw_expr, bool rethrown ATTRIBUTE_UNUSE
 static tree
 objc_build_exc_ptr (struct objc_try_context **cur_try_context)
 {
-  if (flag_objc_sjlj_exceptions)
+  if (GCC_OPTION (flag_objc_sjlj_exceptions))
     {
       tree var = (*cur_try_context)->caught_decl;
       if (!var)
@@ -2927,7 +2927,7 @@ finish_try_stmt (struct objc_try_context **cur_try_context)
   tree stmt;
   struct objc_try_context *c = *cur_try_context;
   /* If we're doing Darwin setjmp exceptions, build the big nasty.  */
-  if (flag_objc_sjlj_exceptions)
+  if (GCC_OPTION (flag_objc_sjlj_exceptions))
     {
       bool save = in_late_binary_op;
       in_late_binary_op = true;
diff --git a/gcc/objc/objc-next-runtime-abi-02.c b/gcc/objc/objc-next-runtime-abi-02.c
index ee43d2d..fd61d44 100644
--- a/gcc/objc/objc-next-runtime-abi-02.c
+++ b/gcc/objc/objc-next-runtime-abi-02.c
@@ -240,11 +240,11 @@ objc_next_runtime_abi_02_init (objc_runtime_hooks *rthooks)
 {
   extern_names = ggc_alloc_cleared_vec_hash (SIZEHASHTABLE);
 
-  if (flag_objc_exceptions && flag_objc_sjlj_exceptions)
+  if (GCC_OPTION (flag_objc_exceptions) && GCC_OPTION (flag_objc_sjlj_exceptions))
     {
       inform (UNKNOWN_LOCATION, "%<-fobjc-sjlj-exceptions%> is ignored for "
 				"%<-fnext-runtime%> when %<-fobjc-abi-version%> >= 2");
-      flag_objc_sjlj_exceptions = 0;
+      GCC_OPTION (flag_objc_sjlj_exceptions) = 0;
     }
 
   rthooks->initialize = next_runtime_02_initialize;
@@ -479,7 +479,7 @@ static void next_runtime_02_initialize (void)
   objc_getPropertyStruct_decl = NULL_TREE;
   objc_setPropertyStruct_decl = NULL_TREE;
 
-  gcc_assert (!flag_objc_sjlj_exceptions);
+  gcc_assert (!GCC_OPTION (flag_objc_sjlj_exceptions));
 
   /* Although we warn that fobjc-exceptions is required for exceptions
      code, we carry on and create it anyway.  */
@@ -1074,7 +1074,7 @@ objc_v2_get_class_reference (tree ident)
 static tree
 next_runtime_abi_02_get_class_reference (tree ident)
 {
-  if (!flag_zero_link)
+  if (!GCC_OPTION (flag_zero_link))
     return objc_v2_get_class_reference (ident);
   else
     {
@@ -1490,7 +1490,7 @@ next_runtime_abi_02_get_category_super_ref (location_t loc ATTRIBUTE_UNUSED,
   tree super_name = CLASS_SUPER_NAME (imp->imp_template);
   tree super_class;
 
-  if (!flag_zero_link)
+  if (!GCC_OPTION (flag_zero_link))
     {
       super_class = objc_get_class_reference (CLASS_NAME (imp->imp_template));
 
@@ -1666,7 +1666,7 @@ next_runtime_abi_02_build_objc_method_call (location_t loc,
 {
   tree ret_type, selector;
   tree message_func_decl;
-  bool check_for_nil = flag_objc_nilcheck;
+  bool check_for_nil = GCC_OPTION (flag_objc_nilcheck);
 
   ret_type = method_prototype
 	     ? TREE_VALUE (TREE_TYPE (method_prototype))
@@ -3350,7 +3350,7 @@ objc_generate_v2_next_metadata (void)
       /* If -gen-decls is present, Dump the @interface of each class.
 	 TODO: Dump the classes in the order they were found, rather
 	 than in reverse order as we are doing now.  */
-      if (flag_gen_declaration)
+      if (GCC_OPTION (flag_gen_declaration))
 	dump_interface (gen_declaration_file, impent->imp_context);
 
       /* all of the following reference the string pool...  */
diff --git a/gcc/objc/objc-runtime-shared-support.c b/gcc/objc/objc-runtime-shared-support.c
index bfdbb4d..accb05f 100644
--- a/gcc/objc/objc-runtime-shared-support.c
+++ b/gcc/objc/objc-runtime-shared-support.c
@@ -506,7 +506,7 @@ build_module_descriptor (long vers, tree attr)
 				       /* FIXME - why the conditional
 					  if the symbol is the
 					  same.  */
-				       flag_next_runtime ? "_OBJC_Module" :  "_OBJC_Module");
+				       GCC_OPTION (flag_next_runtime) ? "_OBJC_Module" :  "_OBJC_Module");
 
   /* This is the root of the metadata for defined classes and categories, it
      is referenced by the runtime and, therefore, needed.  */
@@ -626,7 +626,7 @@ build_next_selector_translation_table (void)
     {
       tree expr;
       tree decl = TREE_PURPOSE (chain);
-      if (warn_selector)
+      if (GCC_OPTION (warn_selector))
 	{
 	  location_t loc;
 	  if (decl)
diff --git a/gcc/omp-low.c b/gcc/omp-low.c
index 7cc398e..9e678e2 100644
--- a/gcc/omp-low.c
+++ b/gcc/omp-low.c
@@ -1961,7 +1961,7 @@ scan_omp_parallel (gimple_stmt_iterator *gsi, omp_context *outer_ctx)
 
   /* Ignore parallel directives with empty bodies, unless there
      are copyin clauses.  */
-  if (optimize > 0
+  if (GCC_OPTION (optimize) > 0
       && empty_body_p (gimple_omp_body (stmt))
       && find_omp_clause (gimple_omp_parallel_clauses (stmt),
 			  OMP_CLAUSE_COPYIN) == NULL)
@@ -2042,7 +2042,7 @@ scan_omp_task (gimple_stmt_iterator *gsi, omp_context *outer_ctx)
   location_t loc = gimple_location (stmt);
 
   /* Ignore task directives with empty bodies.  */
-  if (optimize > 0
+  if (GCC_OPTION (optimize) > 0
       && empty_body_p (gimple_omp_body (stmt)))
     {
       gsi_replace (gsi, gimple_build_nop (), false);
@@ -2927,10 +2927,10 @@ omp_clause_aligned_alignment (tree clause)
 static int
 omp_max_vf (void)
 {
-  if (!optimize
-      || optimize_debug
-      || !flag_tree_loop_optimize
-      || (!flag_tree_loop_vectorize
+  if (!GCC_OPTION (optimize)
+      || GCC_OPTION (optimize_debug)
+      || !GCC_OPTION (flag_tree_loop_optimize)
+      || (!GCC_OPTION (flag_tree_loop_vectorize)
 	  && (global_options_set.x_flag_tree_loop_vectorize
               || global_options_set.x_flag_tree_vectorize)))
     return 1;
@@ -4387,7 +4387,7 @@ maybe_catch_exception (gimple_seq body)
   gimple g;
   tree decl;
 
-  if (!flag_exceptions)
+  if (!GCC_OPTION (flag_exceptions))
     return body;
 
   if (lang_hooks.eh_protect_cleanup_actions != NULL)
@@ -4579,7 +4579,7 @@ optimize_omp_library_calls (gimple entry_stmt)
 		|| gimple_call_num_args (call) != 0)
 	      continue;
 
-	    if (flag_exceptions && !TREE_NOTHROW (decl))
+	    if (GCC_OPTION (flag_exceptions) && !TREE_NOTHROW (decl))
 	      continue;
 
 	    if (TREE_CODE (TREE_TYPE (decl)) != FUNCTION_TYPE
@@ -4839,7 +4839,7 @@ expand_omp_taskreg (struct omp_region *region)
       /* Fix the callgraph edges for child_cfun.  Those for cfun will be
 	 fixed in a following pass.  */
       push_cfun (child_cfun);
-      if (optimize)
+      if (GCC_OPTION (optimize))
 	optimize_omp_library_calls (entry_stmt);
       rebuild_cgraph_edges ();
 
@@ -4847,7 +4847,7 @@ expand_omp_taskreg (struct omp_region *region)
 	 pass_cleanup_cfg isn't the first pass to happen with the
 	 new child, these dead EH edges might cause problems.
 	 Clean them up now.  */
-      if (flag_exceptions)
+      if (GCC_OPTION (flag_exceptions))
 	{
 	  basic_block bb;
 	  bool changed = false;
@@ -6837,10 +6837,10 @@ expand_omp_simd (struct omp_region *region, struct omp_for_data *fd)
 	}
       /* If not -fno-tree-loop-vectorize, hint that we want to vectorize
 	 the loop.  */
-      if ((flag_tree_loop_vectorize
+      if ((GCC_OPTION (flag_tree_loop_vectorize)
 	   || (!global_options_set.x_flag_tree_loop_vectorize
                && !global_options_set.x_flag_tree_vectorize))
-	  && flag_tree_loop_optimize
+	  && GCC_OPTION (flag_tree_loop_optimize)
 	  && loop->safelen > 1)
 	{
 	  loop->force_vect = true;
@@ -7947,7 +7947,7 @@ expand_omp_target (struct omp_region *region)
 	 pass_cleanup_cfg isn't the first pass to happen with the
 	 new child, these dead EH edges might cause problems.
 	 Clean them up now.  */
-      if (flag_exceptions)
+      if (GCC_OPTION (flag_exceptions))
 	{
 	  basic_block bb;
 	  bool changed = false;
@@ -8329,8 +8329,8 @@ execute_expand_omp (void)
 static bool
 gate_expand_omp (void)
 {
-  return ((flag_openmp != 0 || flag_openmp_simd != 0
-	   || flag_cilkplus != 0) && !seen_error ());
+  return ((GCC_OPTION (flag_openmp) != 0 || GCC_OPTION (flag_openmp_simd) != 0
+	   || GCC_OPTION (flag_cilkplus) != 0) && !seen_error ());
 }
 
 namespace {
@@ -10153,7 +10153,7 @@ execute_lower_omp (void)
 
   /* This pass always runs, to provide PROP_gimple_lomp.
      But there is nothing to do unless -fopenmp is given.  */
-  if (flag_openmp == 0 && flag_openmp_simd == 0 && flag_cilkplus == 0)
+  if (GCC_OPTION (flag_openmp) == 0 && GCC_OPTION (flag_openmp_simd) == 0 && GCC_OPTION (flag_cilkplus) == 0)
     return 0;
 
   all_contexts = splay_tree_new (splay_tree_compare_pointers, 0,
@@ -10272,7 +10272,7 @@ diagnose_sb_0 (gimple_stmt_iterator *gsi_p,
 #endif
 
   bool cilkplus_block = false;
-  if (flag_cilkplus)
+  if (GCC_OPTION (flag_cilkplus))
     {
       if ((branch_ctx
 	   && gimple_code (branch_ctx) == GIMPLE_OMP_FOR
@@ -10609,7 +10609,7 @@ diagnose_omp_structured_block_errors (void)
 static bool
 gate_diagnose_omp_blocks (void)
 {
-  return flag_openmp || flag_cilkplus;
+  return GCC_OPTION (flag_openmp) || GCC_OPTION (flag_cilkplus);
 }
 
 namespace {
@@ -10719,7 +10719,7 @@ simd_clone_clauses_extract (struct cgraph_node *node, tree clauses,
      be cloned have a distinctive artificial label in addition to "omp
      declare simd".  */
   bool cilk_clone
-    = (flag_cilkplus
+    = (GCC_OPTION (flag_cilkplus)
        && lookup_attribute ("cilk simd function",
 			    DECL_ATTRIBUTES (node->decl)));
 
@@ -11802,8 +11802,8 @@ public:
   {}
 
   /* opt_pass methods: */
-  bool gate () { return ((flag_openmp || flag_openmp_simd
-			  || flag_cilkplus || (in_lto_p && !flag_wpa))
+  bool gate () { return ((GCC_OPTION (flag_openmp) || GCC_OPTION (flag_openmp_simd)
+			  || GCC_OPTION (flag_cilkplus) || (GCC_OPTION (in_lto_p) && !GCC_OPTION (flag_wpa)))
 			 && (targetm.simd_clone.compute_vecsize_and_simdlen
 			     != NULL)); }
   unsigned int execute () { return ipa_omp_simd_clone (); }
diff --git a/gcc/optabs.c b/gcc/optabs.c
index cec25a4..86cc038 100644
--- a/gcc/optabs.c
+++ b/gcc/optabs.c
@@ -1362,7 +1362,7 @@ avoid_expensive_constant (enum machine_mode mode, optab binoptab,
   bool speed = optimize_insn_for_speed_p ();
 
   if (mode != VOIDmode
-      && optimize
+      && GCC_OPTION (optimize)
       && CONSTANT_P (x)
       && (rtx_cost (x, optab_to_code (binoptab), opn, speed)
 	  > set_src_cost (x, speed)))
@@ -3384,7 +3384,7 @@ expand_abs_nojump (enum machine_mode mode, rtx op0, rtx target,
 {
   rtx temp;
 
-  if (! flag_trapv)
+  if (! GCC_OPTION (flag_trapv))
     result_unsignedp = 1;
 
   /* First try to do it with a special abs instruction.  */
@@ -3449,7 +3449,7 @@ expand_abs (enum machine_mode mode, rtx op0, rtx target,
 {
   rtx temp, op1;
 
-  if (! flag_trapv)
+  if (! GCC_OPTION (flag_trapv))
     result_unsignedp = 1;
 
   temp = expand_abs_nojump (mode, op0, target, result_unsignedp);
@@ -4045,12 +4045,12 @@ prepare_cmp_insn (rtx x, rtx y, enum rtx_code comparison, rtx size,
 	      || methods == OPTAB_LIB_WIDEN);
 
   /* If we are optimizing, force expensive constants into a register.  */
-  if (CONSTANT_P (x) && optimize
+  if (CONSTANT_P (x) && GCC_OPTION (optimize)
       && (rtx_cost (x, COMPARE, 0, optimize_insn_for_speed_p ())
           > COSTS_N_INSNS (1)))
     x = force_reg (mode, x);
 
-  if (CONSTANT_P (y) && optimize
+  if (CONSTANT_P (y) && GCC_OPTION (optimize)
       && (rtx_cost (y, COMPARE, 1, optimize_insn_for_speed_p ())
           > COSTS_N_INSNS (1)))
     y = force_reg (mode, y);
@@ -6284,7 +6284,7 @@ init_sync_libfuncs_1 (optab tab, const char *base, int max)
 void
 init_sync_libfuncs (int max)
 {
-  if (!flag_sync_libcalls)
+  if (!GCC_OPTION (flag_sync_libcalls))
     return;
 
   init_sync_libfuncs_1 (sync_compare_and_swap_optab,
diff --git a/gcc/opts-global.c b/gcc/opts-global.c
index 111884b..612a1c0 100644
--- a/gcc/opts-global.c
+++ b/gcc/opts-global.c
@@ -321,15 +321,15 @@ handle_common_deferred_options (void)
   cl_deferred_option *opt;
   vec<cl_deferred_option> v;
 
-  if (common_deferred_options)
-    v = *((vec<cl_deferred_option> *) common_deferred_options);
+  if (GCC_OPTION (common_deferred_options))
+    v = *((vec<cl_deferred_option> *) GCC_OPTION (common_deferred_options));
   else
     v = vNULL;
 
-  if (flag_dump_all_passed)
+  if (GCC_OPTION (flag_dump_all_passed))
     enable_rtl_dump_file ();
 
-  if (flag_opt_info)
+  if (GCC_OPTION (flag_opt_info))
     opt_info_switch_p (NULL);
 
   FOR_EACH_VEC_ELT (v, i, opt)
diff --git a/gcc/opts.c b/gcc/opts.c
index fdc903f..9a8829c 100644
--- a/gcc/opts.c
+++ b/gcc/opts.c
@@ -1493,9 +1493,9 @@ common_handle_option (struct gcc_options *opts,
 		{
 		  /* Handle both -fsanitize and -fno-sanitize cases.  */
 		  if (value)
-		    flag_sanitize |= spec[i].flag;
+		    GCC_OPTION (flag_sanitize) |= spec[i].flag;
 		  else
-		    flag_sanitize &= ~spec[i].flag;
+		    GCC_OPTION (flag_sanitize) &= ~spec[i].flag;
 		  found = true;
 		  break;
 		}
@@ -1512,7 +1512,7 @@ common_handle_option (struct gcc_options *opts,
 
 	/* When instrumenting the pointers, we don't want to remove
 	   the null pointer checks.  */
-	if (flag_sanitize & SANITIZE_NULL)
+	if (GCC_OPTION (flag_sanitize) & SANITIZE_NULL)
 	  opts->x_flag_delete_null_pointer_checks = 0;
 	break;
       }
diff --git a/gcc/passes.c b/gcc/passes.c
index 60fb135..f050dec 100644
--- a/gcc/passes.c
+++ b/gcc/passes.c
@@ -191,7 +191,7 @@ rest_of_decl_compilation (tree decl,
 
   /* We deferred calling assemble_alias so that we could collect
      other attributes such as visibility.  Emit the alias now.  */
-  if (!in_lto_p)
+  if (!GCC_OPTION (in_lto_p))
   {
     tree alias;
     alias = lookup_attribute ("alias", DECL_ATTRIBUTES (decl));
@@ -235,7 +235,7 @@ rest_of_decl_compilation (tree decl,
 	{
 	  /* When reading LTO unit, we also read varpool, so do not
 	     rebuild it.  */
-	  if (in_lto_p && !at_end)
+	  if (GCC_OPTION (in_lto_p) && !at_end)
 	    ;
 	  else if (finalize && TREE_CODE (decl) != FUNCTION_DECL)
 	    varpool_finalize_decl (decl);
@@ -262,7 +262,7 @@ rest_of_decl_compilation (tree decl,
     }
 
   /* Let cgraph know about the existence of variables.  */
-  if (in_lto_p && !at_end)
+  if (GCC_OPTION (in_lto_p) && !at_end)
     ;
   else if (TREE_CODE (decl) == VAR_DECL && !DECL_EXTERNAL (decl)
 	   && TREE_STATIC (decl))
@@ -296,14 +296,14 @@ finish_optimization_passes (void)
   gcc::dump_manager *dumps = m_ctxt->get_dumps ();
 
   timevar_push (TV_DUMP);
-  if (profile_arc_flag || flag_test_coverage || flag_branch_probabilities)
+  if (GCC_OPTION (profile_arc_flag) || GCC_OPTION (flag_test_coverage) || GCC_OPTION (flag_branch_probabilities))
     {
       dumps->dump_start (pass_profile_1->static_pass_number, NULL);
       end_branch_prob ();
       dumps->dump_finish (pass_profile_1->static_pass_number);
     }
 
-  if (optimize > 0)
+  if (GCC_OPTION (optimize) > 0)
     {
       dumps->dump_start (pass_profile_1->static_pass_number, NULL);
       print_combine_total_stats ();
@@ -343,7 +343,7 @@ static bool
 gate_all_early_local_passes (void)
 {
 	  /* Don't bother doing anything if the program has errors.  */
-  return (!seen_error () && !in_lto_p);
+  return (!seen_error () && !GCC_OPTION (in_lto_p));
 }
 
 namespace {
@@ -389,7 +389,7 @@ make_pass_early_local_passes (gcc::context *ctxt)
 static bool
 gate_all_early_optimizations (void)
 {
-  return (optimize >= 1
+  return (GCC_OPTION (optimize) >= 1
 	  /* Don't bother doing anything if the program has errors.  */
 	  && !seen_error ());
 }
@@ -436,7 +436,7 @@ make_pass_all_early_optimizations (gcc::context *ctxt)
 static bool
 gate_all_optimizations (void)
 {
-  return optimize >= 1 && !optimize_debug;
+  return GCC_OPTION (optimize) >= 1 && !GCC_OPTION (optimize_debug);
 }
 
 namespace {
@@ -481,7 +481,7 @@ make_pass_all_optimizations (gcc::context *ctxt)
 static bool
 gate_all_optimizations_g (void)
 {
-  return optimize >= 1 && optimize_debug;
+  return GCC_OPTION (optimize) >= 1 && GCC_OPTION (optimize_debug);
 }
 
 namespace {
@@ -526,7 +526,7 @@ gate_rest_of_compilation (void)
 {
   /* Early return if there were errors.  We can run afoul of our
      consistency checks, and there's not really much point in fixing them.  */
-  return !(rtl_dump_and_exit || flag_syntax_only || seen_error ());
+  return !(GCC_OPTION (rtl_dump_and_exit) || GCC_OPTION (flag_syntax_only) || seen_error ());
 }
 
 namespace {
@@ -835,7 +835,7 @@ passes_pass_traverse (pass_registry **p, void *data ATTRIBUTE_UNUSED)
 static void
 create_pass_tab (void)
 {
-  if (!flag_dump_passes)
+  if (!GCC_OPTION (flag_dump_passes))
     return;
 
   pass_tab.safe_grow_cleared (g->get_passes ()->passes_by_id_size + 1);
@@ -1581,7 +1581,7 @@ do_per_function (void (*callback) (void *data), void *data)
 	  {
 	    push_cfun (DECL_STRUCT_FUNCTION (node->decl));
 	    callback (data);
-	    if (!flag_wpa)
+	    if (!GCC_OPTION (flag_wpa))
 	      {
 	        free_dominance_info (CDI_DOMINATORS);
 	        free_dominance_info (CDI_POST_DOMINATORS);
@@ -1827,10 +1827,10 @@ execute_function_todo (void *data)
       cfun->last_verified &= ~TODO_verify_ssa;
     }
 
-  if (flag_tree_pta && (flags & TODO_rebuild_alias))
+  if (GCC_OPTION (flag_tree_pta) && (flags & TODO_rebuild_alias))
     compute_may_aliases ();
 
-  if (optimize && (flags & TODO_update_address_taken))
+  if (GCC_OPTION (optimize) && (flags & TODO_update_address_taken))
     execute_update_addresses_taken ();
 
   if (flags & TODO_remove_unused_locals)
@@ -2069,13 +2069,13 @@ execute_one_ipa_transform_pass (struct cgraph_node *node,
   if (pass->tv_id != TV_NONE)
     timevar_pop (pass->tv_id);
 
-  if (profile_report && cfun && (cfun->curr_properties & PROP_cfg))
+  if (GCC_OPTION (profile_report) && cfun && (cfun->curr_properties & PROP_cfg))
     check_profile_consistency (pass->static_pass_number, 0, true);
 
   /* Run post-pass cleanup and verification.  */
   execute_todo (todo_after);
   verify_interpass_invariants ();
-  if (profile_report && cfun && (cfun->curr_properties & PROP_cfg))
+  if (GCC_OPTION (profile_report) && cfun && (cfun->curr_properties & PROP_cfg))
     check_profile_consistency (pass->static_pass_number, 1, true);
 
   if (dump_file)
@@ -2177,7 +2177,7 @@ execute_one_pass (opt_pass *pass)
     {
       /* Run so passes selectively disabling themselves on a given function
 	 are not miscounted.  */
-      if (profile_report && cfun && (cfun->curr_properties & PROP_cfg))
+      if (GCC_OPTION (profile_report) && cfun && (cfun->curr_properties & PROP_cfg))
 	{
           check_profile_consistency (pass->static_pass_number, 0, false);
           check_profile_consistency (pass->static_pass_number, 1, false);
@@ -2202,7 +2202,7 @@ execute_one_pass (opt_pass *pass)
       current_pass = pass;
     }
 
-  if (!quiet_flag && !cfun)
+  if (!GCC_OPTION (quiet_flag) && !cfun)
     fprintf (stderr, " <%s>", pass->name ? pass->name : "");
 
   /* Note that the folders should only create gimple expressions.
@@ -2236,12 +2236,12 @@ execute_one_pass (opt_pass *pass)
 
   do_per_function (update_properties_after_pass, pass);
 
-  if (profile_report && cfun && (cfun->curr_properties & PROP_cfg))
+  if (GCC_OPTION (profile_report) && cfun && (cfun->curr_properties & PROP_cfg))
     check_profile_consistency (pass->static_pass_number, 0, true);
 
   /* Run post-pass cleanup and verification.  */
   execute_todo (todo_after | pass->todo_flags_finish);
-  if (profile_report && cfun && (cfun->curr_properties & PROP_cfg))
+  if (GCC_OPTION (profile_report) && cfun && (cfun->curr_properties & PROP_cfg))
     check_profile_consistency (pass->static_pass_number, 1, true);
 
   verify_interpass_invariants ();
@@ -2350,7 +2350,7 @@ ipa_write_summaries_1 (lto_symtab_encoder_t encoder)
 
   lto_push_out_decl_state (state);
 
-  gcc_assert (!flag_wpa);
+  gcc_assert (!GCC_OPTION (flag_wpa));
   ipa_write_summaries_2 (passes->all_regular_ipa_passes, state);
 
   write_lto ();
@@ -2371,7 +2371,7 @@ ipa_write_summaries (void)
   struct cgraph_node *node;
   struct cgraph_node **order;
 
-  if (!flag_generate_lto || seen_error ())
+  if (!GCC_OPTION (flag_generate_lto) || seen_error ())
     return;
 
   encoder = lto_symtab_encoder_new (false);
@@ -2484,7 +2484,7 @@ ipa_write_optimization_summaries (lto_symtab_encoder_t encoder)
 	}
     }
 
-  gcc_assert (flag_wpa);
+  gcc_assert (GCC_OPTION (flag_wpa));
   pass_manager *passes = g->get_passes ();
   ipa_write_optimization_summaries_1 (passes->all_regular_ipa_passes, state);
 
diff --git a/gcc/plugin.c b/gcc/plugin.c
index 88c1780..7deddf8 100644
--- a/gcc/plugin.c
+++ b/gcc/plugin.c
@@ -885,7 +885,7 @@ get_event_last (void)
 const char*
 default_plugin_dir_name (void)
 {
-  if (!plugindir_string)
+  if (!GCC_OPTION (plugindir_string))
     fatal_error ("-iplugindir <dir> option not passed from the gcc driver");
-  return plugindir_string;
+  return GCC_OPTION (plugindir_string);
 }
diff --git a/gcc/postreload-gcse.c b/gcc/postreload-gcse.c
index 5555794..f2704ca 100644
--- a/gcc/postreload-gcse.c
+++ b/gcc/postreload-gcse.c
@@ -806,7 +806,7 @@ hash_scan_set (rtx insn)
 	  /* As above for STACK_REGS.  */
 	  && (REGNO (src) < FIRST_STACK_REG || REGNO (src) > LAST_STACK_REG)
 #endif
-	  && ! (flag_float_store && FLOAT_MODE_P (GET_MODE (dest)))
+	  && ! (GCC_OPTION (flag_float_store) && FLOAT_MODE_P (GET_MODE (dest)))
 	  /* Check if the memory expression is killed after insn.  */
 	  && ! load_killed_in_block_p (INSN_CUID (insn) + 1, dest, true)
 	  && oprs_unchanged_p (XEXP (dest, 0), insn, true))
@@ -1066,7 +1066,7 @@ eliminate_partially_redundant_load (basic_block bb, rtx insn,
       || (optimize_bb_for_size_p (bb) && npred_ok > 1)
       /* If we don't have profile information we cannot tell if splitting
          a critical edge is profitable or not so don't do it.  */
-      || ((! profile_info || ! flag_branch_probabilities
+      || ((! profile_info || ! GCC_OPTION (flag_branch_probabilities)
 	   || targetm.cannot_modify_jumps_p ())
 	  && critical_edge_split))
     goto cleanup;
@@ -1311,7 +1311,7 @@ gcse_after_reload_main (rtx f ATTRIBUTE_UNUSED)
 static bool
 gate_handle_gcse2 (void)
 {
-  return (optimize > 0 && flag_gcse_after_reload
+  return (GCC_OPTION (optimize) > 0 && GCC_OPTION (flag_gcse_after_reload)
 	  && optimize_function_for_speed_p (cfun));
 }
 
